import React from 'react';
import { changeColor } from './commands';
import { createPlugin, highlightPluginKey } from './pm-plugin';
import { ToolbarHighlightColorWithIntl as ToolbarHighlightColor } from './ui/ToolbarHighlightColor';
export const highlightPlugin = ({
  api
}) => {
  var _api$analytics;
  const editorAnalyticsAPI = api === null || api === void 0 ? void 0 : (_api$analytics = api.analytics) === null || _api$analytics === void 0 ? void 0 : _api$analytics.actions;
  const primaryToolbarComponent = ({
    popupsMountPoint,
    popupsBoundariesElement,
    popupsScrollableElement,
    disabled,
    isToolbarReducedSpacing,
    dispatchAnalyticsEvent
  }) => /*#__PURE__*/React.createElement(ToolbarHighlightColor, {
    popupsMountPoint: popupsMountPoint,
    popupsBoundariesElement: popupsBoundariesElement,
    popupsScrollableElement: popupsScrollableElement,
    disabled: disabled,
    isToolbarReducedSpacing: isToolbarReducedSpacing,
    dispatchAnalyticsEvent: dispatchAnalyticsEvent,
    pluginInjectionApi: api
  });
  return {
    name: 'highlight',
    commands: {
      changeColor: changeColor(editorAnalyticsAPI)
    },
    pmPlugins: () => [{
      name: 'highlight',
      plugin: () => createPlugin({
        api
      })
    }],
    getSharedState(editorState) {
      if (!editorState) {
        return;
      }
      return highlightPluginKey.getState(editorState);
    },
    usePluginHook: () => {
      var _api$core, _api$primaryToolbar;
      api === null || api === void 0 ? void 0 : (_api$core = api.core) === null || _api$core === void 0 ? void 0 : _api$core.actions.execute(api === null || api === void 0 ? void 0 : (_api$primaryToolbar = api.primaryToolbar) === null || _api$primaryToolbar === void 0 ? void 0 : _api$primaryToolbar.commands.registerComponent({
        name: 'highlight',
        component: primaryToolbarComponent
      }));
    },
    primaryToolbarComponent: !(api !== null && api !== void 0 && api.primaryToolbar) ? primaryToolbarComponent : undefined
  };
};